# Exponentiation and converting binary lists to decimal numbers

# A function to raise base to the exponent power
def exponentiate(base,exponent):
  ans = 1
  for i in range(exponent):
    ans = ans * base
  return ans

twoTofour = exponentiate(2,4)   # 16
threeToFive = exponentiate(3,5) # 243
eightTozero = exponentiate(8,0) # 1
nineTothird = exponentiate(9,3) # 729

print(twoTofour)
print(threeToFive)
print(eightTozero)
print(nineTothird)

print()

# Convert binary to decimal numbers by going from back to front
def binary_to_decimal_backwards(binaryL):
  sum = 0
  pow = 0
  for i in range(len(binaryL)-1,-1,-1):
    if binaryL[i]==1:
      sum = sum + exponentiate(2,pow)
    pow = pow+1
  return sum


# Convert binary to decimal numbers by going from front to back
def binary_to_decimal_forwards(binaryL):
  sum = 0
  pow = len(binaryL)
  for i in range(len(binaryL)):
    pow = pow-1
    if binaryL[i]==1:
      sum = sum + exponentiate(2,pow)
  return sum

# Convert binary to decimal numbers by going from front to back but
# use multiplication instead of if conditions
def binary_to_decimal(binaryL):
  sum = 0
  pow = len(binaryL)
  for i in range(len(binaryL)):
    pow = pow-1
    sum = sum + binaryL[i]*exponentiate(2,pow)
  return sum

bin1 = [1,1,0,1,1,0]
bin2 = [1,0,1,0,1,1,1]

print(binary_to_decimal(bin1))
print(binary_to_decimal(bin2))
